import { NgModule, Injectable, Injector } from '@angular/core';
import { HttpClient, HttpClientModule } from '@angular/common/http';
import { Observable } from 'rxjs';
import { __extends } from 'tslib';
import { Router, ActivatedRoute, RouterModule } from '@angular/router';
import { Title, BrowserModule } from '@angular/platform-browser';

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/globals/globals.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
var  /**
 * @abstract
 */
XoGlobals = /** @class */ (function () {
    function XoGlobals() {
    }
    return XoGlobals;
}());
if (false) {
    /**
     * @abstract
     * @return {?}
     */
    XoGlobals.prototype.appConfig = function () { };
    /**
     * @abstract
     * @return {?}
     */
    XoGlobals.prototype.apiCache = function () { };
}
var XoBrowserGlobals = /** @class */ (function (_super) {
    __extends(XoBrowserGlobals, _super);
    function XoBrowserGlobals() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(XoBrowserGlobals.prototype, "appConfig", {
        get: /**
         * @return {?}
         */
        function () {
            return window['appConfig'] || (/** @type {?} */ ({}));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XoBrowserGlobals.prototype, "apiCache", {
        get: /**
         * @return {?}
         */
        function () {
            return window['apiCache'] || (/** @type {?} */ ({}));
        },
        enumerable: true,
        configurable: true
    });
    return XoBrowserGlobals;
}(XoGlobals));
var XoNodeGlobals = /** @class */ (function (_super) {
    __extends(XoNodeGlobals, _super);
    function XoNodeGlobals() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(XoNodeGlobals.prototype, "appConfig", {
        get: /**
         * @return {?}
         */
        function () {
            return {};
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(XoNodeGlobals.prototype, "apiCache", {
        get: /**
         * @return {?}
         */
        function () {
            return {};
        },
        enumerable: true,
        configurable: true
    });
    return XoNodeGlobals;
}(XoGlobals));
var XoGlobalsModule = /** @class */ (function () {
    function XoGlobalsModule() {
    }
    /**
     * @return {?}
     */
    XoGlobalsModule.forBrowser = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: XoGlobalsModule,
            providers: [
                { provide: XoGlobals, useClass: XoBrowserGlobals }
            ]
        };
    };
    /**
     * @return {?}
     */
    XoGlobalsModule.forNode = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: XoGlobalsModule,
            providers: [
                { provide: XoGlobals, useClass: XoNodeGlobals }
            ]
        };
    };
    XoGlobalsModule.decorators = [
        { type: NgModule, args: [{},] }
    ];
    return XoGlobalsModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/apiRequest.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoApiRequestService = /** @class */ (function () {
    function XoApiRequestService(_globals, _http) {
        this._globals = _globals;
        this._http = _http;
        /**
         * Base path or URL of the Xo API.
         */
        this.apiUrl = '';
        if (('paths' in this._globals.appConfig)
            && ('apiUrl' in this._globals.appConfig.paths)) {
            this.apiUrl = this._globals.appConfig.paths.apiUrl;
        }
    }
    /**
     * Perform a GET request to the Xo API.
     *
     * @param path Relative path of the API endpoint.
     * @param params Input parameters added to the GET request.
     * @param useCache Pro feature, optionally retrieve the item from apiCache.
     */
    /**
     * Perform a GET request to the Xo API.
     *
     * @template T
     * @param {?} path Relative path of the API endpoint.
     * @param {?=} params Input parameters added to the GET request.
     * @param {?=} useCache Pro feature, optionally retrieve the item from apiCache.
     * @return {?}
     */
    XoApiRequestService.prototype.get = /**
     * Perform a GET request to the Xo API.
     *
     * @template T
     * @param {?} path Relative path of the API endpoint.
     * @param {?=} params Input parameters added to the GET request.
     * @param {?=} useCache Pro feature, optionally retrieve the item from apiCache.
     * @return {?}
     */
    function (path, params, useCache) {
        var _this = this;
        return this.cacheCheck(path, params, useCache, (/**
         * @return {?}
         */
        function () {
            return _this._http.get(_this.apiUrl + path, { params: params });
        }));
    };
    /**
     * Perform a POST request to the Xo API.
     *
     * @param path Relative path of the API endpoint.
     * @param params Input parameters added to the POST request.
     * @param useCache Pro feature, optionally retrieve the item from apiCache.
     */
    /**
     * Perform a POST request to the Xo API.
     *
     * @template T
     * @param {?} path Relative path of the API endpoint.
     * @param {?} params Input parameters added to the POST request.
     * @param {?=} useCache Pro feature, optionally retrieve the item from apiCache.
     * @return {?}
     */
    XoApiRequestService.prototype.post = /**
     * Perform a POST request to the Xo API.
     *
     * @template T
     * @param {?} path Relative path of the API endpoint.
     * @param {?} params Input parameters added to the POST request.
     * @param {?=} useCache Pro feature, optionally retrieve the item from apiCache.
     * @return {?}
     */
    function (path, params, useCache) {
        var _this = this;
        return this.cacheCheck(path, params, useCache, (/**
         * @return {?}
         */
        function () {
            return _this._http.post(_this.apiUrl + path, params);
        }));
    };
    /**
     * @private
     * @template T
     * @param {?} url
     * @param {?} params
     * @param {?} useCache
     * @param {?} callback
     * @return {?}
     */
    XoApiRequestService.prototype.cacheCheck = /**
     * @private
     * @template T
     * @param {?} url
     * @param {?} params
     * @param {?} useCache
     * @param {?} callback
     * @return {?}
     */
    function (url, params, useCache, callback) {
        var _this = this;
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            var next = observer.next, error = observer.error;
            /** @type {?} */
            var key = url + ((params) ? ':' + JSON.stringify(params) : '');
            if (((useCache) || (typeof useCache === 'undefined'))
                && (_this._globals.apiCache[key])) {
                observer.next(_this._globals.apiCache[key]);
            }
            else {
                if (callback) {
                    callback().subscribe((/**
                     * @param {?} response
                     * @return {?}
                     */
                    function (response) {
                        observer.next(response);
                    }));
                }
                else {
                    observer.error();
                }
            }
        }));
    };
    XoApiRequestService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoApiRequestService.ctorParameters = function () { return [
        { type: XoGlobals },
        { type: HttpClient }
    ]; };
    return XoApiRequestService;
}());
if (false) {
    /**
     * Base path or URL of the Xo API.
     * @type {?}
     */
    XoApiRequestService.prototype.apiUrl;
    /** @type {?} */
    XoApiRequestService.prototype._globals;
    /** @type {?} */
    XoApiRequestService.prototype._http;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/api.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoApiService = /** @class */ (function () {
    function XoApiService(_request) {
        this._request = _request;
    }
    XoApiService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoApiService.ctorParameters = function () { return [
        { type: XoApiRequestService }
    ]; };
    return XoApiService;
}());
if (false) {
    /** @type {?} */
    XoApiService.prototype._request;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/config/config.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Provide endpoints for retrieving the main site configuration.
 */
var XoApiConfigService = /** @class */ (function (_super) {
    __extends(XoApiConfigService, _super);
    function XoApiConfigService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Get the main site configuration.
     */
    /**
     * Get the main site configuration.
     * @param {?} name
     * @return {?}
     */
    XoApiConfigService.prototype.get = /**
     * Get the main site configuration.
     * @param {?} name
     * @return {?}
     */
    function (name) {
        return this._request.get('/config/get');
    };
    XoApiConfigService.decorators = [
        { type: Injectable }
    ];
    return XoApiConfigService;
}(XoApiService));

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/menus/menus.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Provide endpoints for retrieving navigation menus.
 */
var XoApiMenusService = /** @class */ (function (_super) {
    __extends(XoApiMenusService, _super);
    function XoApiMenusService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Get a navigation menu by location name.
     */
    /**
     * Get a navigation menu by location name.
     * @param {?} name
     * @return {?}
     */
    XoApiMenusService.prototype.get = /**
     * Get a navigation menu by location name.
     * @param {?} name
     * @return {?}
     */
    function (name) {
        return this._request.get('/menus/get', {
            menu: name
        });
    };
    XoApiMenusService.decorators = [
        { type: Injectable }
    ];
    return XoApiMenusService;
}(XoApiService));

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/options/options.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Provide endpoints for retrieving option groups.
 */
var XoApiOptionsService = /** @class */ (function (_super) {
    __extends(XoApiOptionsService, _super);
    function XoApiOptionsService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Get an option group by name.
     */
    /**
     * Get an option group by name.
     * @param {?} name
     * @return {?}
     */
    XoApiOptionsService.prototype.get = /**
     * Get an option group by name.
     * @param {?} name
     * @return {?}
     */
    function (name) {
        return this._request.get('/options/get', {
            name: name
        });
    };
    XoApiOptionsService.decorators = [
        { type: Injectable }
    ];
    return XoApiOptionsService;
}(XoApiService));

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/posts/posts.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Provide endpoints for retrieving, searching, and listing various post types.
 */
var XoApiPostsService = /** @class */ (function (_super) {
    __extends(XoApiPostsService, _super);
    function XoApiPostsService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Get a post using either the relative URL or postId.
     */
    /**
     * Get a post using either the relative URL or postId.
     * @param {?} url
     * @return {?}
     */
    XoApiPostsService.prototype.get = /**
     * Get a post using either the relative URL or postId.
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return this._request.get('/posts/get', {
            url: url
        });
    };
    /**
     * Get a post draft or preview only if user logged in and can view.
     */
    /**
     * Get a post draft or preview only if user logged in and can view.
     * @param {?} postId
     * @return {?}
     */
    XoApiPostsService.prototype.getDraftOrPreview = /**
     * Get a post draft or preview only if user logged in and can view.
     * @param {?} postId
     * @return {?}
     */
    function (postId) {
        return this._request.get('/posts/getDraftOrPreview', {
            postId: postId
        });
    };
    /**
     * Filter, search, or list posts by various properties similar to get_posts().
     */
    /**
     * Filter, search, or list posts by various properties similar to get_posts().
     * @param {?} params
     * @return {?}
     */
    XoApiPostsService.prototype.filter = /**
     * Filter, search, or list posts by various properties similar to get_posts().
     * @param {?} params
     * @return {?}
     */
    function (params) {
        return this._request.post('/posts/filter', params);
    };
    /**
     * Retrieve the config for a given post type.
     */
    /**
     * Retrieve the config for a given post type.
     * @param {?} postType
     * @return {?}
     */
    XoApiPostsService.prototype.config = /**
     * Retrieve the config for a given post type.
     * @param {?} postType
     * @return {?}
     */
    function (postType) {
        return this._request.get('/posts/config', {
            postType: postType
        });
    };
    XoApiPostsService.decorators = [
        { type: Injectable }
    ];
    return XoApiPostsService;
}(XoApiService));

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/routes/routes.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Provide endpoints for retrieving dynamic routes and sitemap.
 */
var XoApiRoutesService = /** @class */ (function (_super) {
    __extends(XoApiRoutesService, _super);
    function XoApiRoutesService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Get the dynamic route configuration.
     */
    /**
     * Get the dynamic route configuration.
     * @return {?}
     */
    XoApiRoutesService.prototype.get = /**
     * Get the dynamic route configuration.
     * @return {?}
     */
    function () {
        return this._request.get('/routes/get');
    };
    /**
     * Get breadcrumb sitemap entries for the given URL.
     */
    /**
     * Get breadcrumb sitemap entries for the given URL.
     * @param {?} url
     * @return {?}
     */
    XoApiRoutesService.prototype.breadcrumbs = /**
     * Get breadcrumb sitemap entries for the given URL.
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return this._request.get('/routes/breadcrumbs', {
            url: url
        });
    };
    /**
     * Get sitemap entries for posts and terms.
     */
    /**
     * Get sitemap entries for posts and terms.
     * @return {?}
     */
    XoApiRoutesService.prototype.sitemap = /**
     * Get sitemap entries for posts and terms.
     * @return {?}
     */
    function () {
        return this._request.get('/routes/sitemap');
    };
    XoApiRoutesService.decorators = [
        { type: Injectable }
    ];
    return XoApiRoutesService;
}(XoApiService));

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/terms/terms.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Provide endpoints for filtering terms.
 */
var XoApiTermsService = /** @class */ (function (_super) {
    __extends(XoApiTermsService, _super);
    function XoApiTermsService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Get a taxonomy and term by url.
     */
    /**
     * Get a taxonomy and term by url.
     * @param {?} url
     * @return {?}
     */
    XoApiTermsService.prototype.get = /**
     * Get a taxonomy and term by url.
     * @param {?} url
     * @return {?}
     */
    function (url) {
        return this._request.get('/terms/get', {
            url: url
        });
    };
    /**
     * Filter, search, or list terms by various properties similar to get_terms().
     */
    /**
     * Filter, search, or list terms by various properties similar to get_terms().
     * @param {?} params
     * @return {?}
     */
    XoApiTermsService.prototype.filter = /**
     * Filter, search, or list terms by various properties similar to get_terms().
     * @param {?} params
     * @return {?}
     */
    function (params) {
        return this._request.post('/terms/filter', params);
    };
    XoApiTermsService.decorators = [
        { type: Injectable }
    ];
    return XoApiTermsService;
}(XoApiService));

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/routes/route.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoRouteService = /** @class */ (function () {
    function XoRouteService(_injector, _routesService) {
        this._injector = _injector;
        this._routesService = _routesService;
    }
    /**
     * @return {?}
     */
    XoRouteService.prototype.getRoutes = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var router = this._injector.get(Router);
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            _this._routesService.get()
                .subscribe((/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (response.success)
                    router.resetConfig(response.routes);
                resolve(true);
            }));
        }));
    };
    XoRouteService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoRouteService.ctorParameters = function () { return [
        { type: Injector },
        { type: XoApiRoutesService }
    ]; };
    return XoRouteService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    XoRouteService.prototype._injector;
    /**
     * @type {?}
     * @private
     */
    XoRouteService.prototype._routesService;
}
/**
 * @param {?} _routeService
 * @return {?}
 */
function XoInitRoutes(_routeService) {
    return (/**
     * @return {?}
     */
    function () { return _routeService.getRoutes(); });
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/posts/post.resolver.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoPostResolver = /** @class */ (function () {
    function XoPostResolver(_postService) {
        this._postService = _postService;
    }
    /**
     * @param {?} _route
     * @param {?} _state
     * @return {?}
     */
    XoPostResolver.prototype.resolve = /**
     * @param {?} _route
     * @param {?} _state
     * @return {?}
     */
    function (_route, _state) {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            /** @type {?} */
            var onSubscribe = (/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (response.success)
                    resolve(response.post);
                reject();
            });
            if (_route.data.postId) {
                _this._postService.getDraftOrPreview(_route.data.postId)
                    .subscribe(onSubscribe);
            }
            else if (_route.parent.data['postPreview']) {
                _this._postService.getDraftOrPreview(_route.params['slug'])
                    .subscribe(onSubscribe);
            }
            else {
                /** @type {?} */
                var url = ((_route.data.url) ? (_route.data.url) : _state.url.split(/[?#]/)[0]);
                _this._postService.get(url).subscribe(onSubscribe);
            }
        }));
    };
    XoPostResolver.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoPostResolver.ctorParameters = function () { return [
        { type: XoApiPostsService }
    ]; };
    return XoPostResolver;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    XoPostResolver.prototype._postService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/components/posts/post.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoPostComponent = /** @class */ (function () {
    function XoPostComponent(_router, _route, _title, _globals) {
        this._router = _router;
        this._route = _route;
        this._title = _title;
        this._globals = _globals;
        this._router.routeReuseStrategy.shouldReuseRoute = (/**
         * @return {?}
         */
        function () { return false; });
    }
    /**
     * @return {?}
     */
    XoPostComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.setPost();
    };
    /**
     * @return {?}
     */
    XoPostComponent.prototype.setPost = /**
     * @return {?}
     */
    function () {
        if (this._route.snapshot.data['breadcrumbs']) {
            this.breadcrumbs = this._route.snapshot.data['breadcrumbs'];
        }
        if (this._route.snapshot.data['post']) {
            this.post = this._route.snapshot.data['post'];
            this.setTitle();
        }
    };
    /**
     * @return {?}
     */
    XoPostComponent.prototype.setTitle = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var title = ((this.post.title) ? this.post.title + ' | ' : '') + this._globals.appConfig.app.title;
        this._title.setTitle(title);
    };
    XoPostComponent.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoPostComponent.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: Title },
        { type: XoGlobals }
    ]; };
    return XoPostComponent;
}());
if (false) {
    /** @type {?} */
    XoPostComponent.prototype.breadcrumbs;
    /** @type {?} */
    XoPostComponent.prototype.post;
    /** @type {?} */
    XoPostComponent.prototype._router;
    /** @type {?} */
    XoPostComponent.prototype._route;
    /** @type {?} */
    XoPostComponent.prototype._title;
    /** @type {?} */
    XoPostComponent.prototype._globals;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/components/posts/postsList.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoPostsListComponent = /** @class */ (function (_super) {
    __extends(XoPostsListComponent, _super);
    function XoPostsListComponent(_router, _route, _title, _globals, _posts) {
        var _this = _super.call(this, _router, _route, _title, _globals) || this;
        _this._router = _router;
        _this._route = _route;
        _this._title = _title;
        _this._globals = _globals;
        _this._posts = _posts;
        _this.posts = [];
        _this.postsTotal = 0;
        _this.pageCount = 0;
        _this.postsFilterArgs = {
            currentPage: 1,
            postsPerPage: 10
        };
        return _this;
    }
    /**
     * @return {?}
     */
    XoPostsListComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.post = this._route.snapshot.data['post'];
        this.getPosts();
    };
    /**
     * @return {?}
     */
    XoPostsListComponent.prototype.getPosts = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this._posts.filter(this.postsFilterArgs)
            .subscribe((/**
         * @param {?} response
         * @return {?}
         */
        function (response) {
            if (response.success) {
                _this.posts = response.posts;
                _this.postsTotal = response.total;
                _this.setPageCount();
            }
        }));
    };
    /**
     * @return {?}
     */
    XoPostsListComponent.prototype.setPageCount = /**
     * @return {?}
     */
    function () {
        if (this.postsFilterArgs.postsPerPage)
            this.pageCount = Math.ceil(this.postsTotal / this.postsFilterArgs.postsPerPage);
        else
            this.pageCount = 1;
    };
    XoPostsListComponent.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoPostsListComponent.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: Title },
        { type: XoGlobals },
        { type: XoApiPostsService }
    ]; };
    return XoPostsListComponent;
}(XoPostComponent));
if (false) {
    /** @type {?} */
    XoPostsListComponent.prototype.posts;
    /** @type {?} */
    XoPostsListComponent.prototype.postsTotal;
    /** @type {?} */
    XoPostsListComponent.prototype.pageCount;
    /** @type {?} */
    XoPostsListComponent.prototype.postsFilterArgs;
    /** @type {?} */
    XoPostsListComponent.prototype._router;
    /** @type {?} */
    XoPostsListComponent.prototype._route;
    /** @type {?} */
    XoPostsListComponent.prototype._title;
    /** @type {?} */
    XoPostsListComponent.prototype._globals;
    /** @type {?} */
    XoPostsListComponent.prototype._posts;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/components/posts/postTerm.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoPostTermComponent = /** @class */ (function (_super) {
    __extends(XoPostTermComponent, _super);
    function XoPostTermComponent(_router, _route, _title, _globals) {
        var _this = _super.call(this, _router, _route, _title, _globals) || this;
        _this._router = _router;
        _this._route = _route;
        _this._title = _title;
        _this._globals = _globals;
        return _this;
    }
    /**
     * @return {?}
     */
    XoPostTermComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.setPost();
        this.setTerm();
    };
    /**
     * @return {?}
     */
    XoPostTermComponent.prototype.setTerm = /**
     * @return {?}
     */
    function () {
        if (this._route.snapshot.data['term']) {
            this.term = this._route.snapshot.data['term'];
        }
    };
    XoPostTermComponent.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoPostTermComponent.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: Title },
        { type: XoGlobals }
    ]; };
    return XoPostTermComponent;
}(XoPostComponent));
if (false) {
    /** @type {?} */
    XoPostTermComponent.prototype.term;
    /** @type {?} */
    XoPostTermComponent.prototype._router;
    /** @type {?} */
    XoPostTermComponent.prototype._route;
    /** @type {?} */
    XoPostTermComponent.prototype._title;
    /** @type {?} */
    XoPostTermComponent.prototype._globals;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/terms/term.resolver.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoTermResolver = /** @class */ (function () {
    function XoTermResolver(_termsService) {
        this._termsService = _termsService;
    }
    /**
     * @param {?} _route
     * @param {?} _state
     * @return {?}
     */
    XoTermResolver.prototype.resolve = /**
     * @param {?} _route
     * @param {?} _state
     * @return {?}
     */
    function (_route, _state) {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            /** @type {?} */
            var onSubscribe = (/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (response.success)
                    resolve(response.term);
                reject();
            });
            /** @type {?} */
            var url = ((_route.data.url) ? (_route.data.url) : _state.url.split(/[?#]/)[0]);
            _this._termsService.get(url).subscribe(onSubscribe);
        }));
    };
    XoTermResolver.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoTermResolver.ctorParameters = function () { return [
        { type: XoApiTermsService }
    ]; };
    return XoTermResolver;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    XoTermResolver.prototype._termsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/components/terms/term.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoTermComponent = /** @class */ (function () {
    function XoTermComponent(_router, _route, _title, _globals) {
        this._router = _router;
        this._route = _route;
        this._title = _title;
        this._globals = _globals;
        this._router.routeReuseStrategy.shouldReuseRoute = (/**
         * @return {?}
         */
        function () { return false; });
    }
    /**
     * @return {?}
     */
    XoTermComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.setTerm();
    };
    /**
     * @return {?}
     */
    XoTermComponent.prototype.setTerm = /**
     * @return {?}
     */
    function () {
        if (this._route.snapshot.data['breadcrumbs']) {
            this.breadcrumbs = this._route.snapshot.data['breadcrumbs'];
        }
        if (this._route.snapshot.data['term']) {
            this.term = this._route.snapshot.data['term'];
            this.setTitle();
        }
    };
    /**
     * @return {?}
     */
    XoTermComponent.prototype.setTitle = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var title = ((this.term.name) ? this.term.name + ' | ' : '') + this._globals.appConfig.app.title;
        this._title.setTitle(title);
    };
    XoTermComponent.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoTermComponent.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: Title },
        { type: XoGlobals }
    ]; };
    return XoTermComponent;
}());
if (false) {
    /** @type {?} */
    XoTermComponent.prototype.breadcrumbs;
    /** @type {?} */
    XoTermComponent.prototype.term;
    /** @type {?} */
    XoTermComponent.prototype._router;
    /** @type {?} */
    XoTermComponent.prototype._route;
    /** @type {?} */
    XoTermComponent.prototype._title;
    /** @type {?} */
    XoTermComponent.prototype._globals;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/routes/breadcrumbs.resolver.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoBreadcrumbsResolver = /** @class */ (function () {
    function XoBreadcrumbsResolver(_routesService) {
        this._routesService = _routesService;
    }
    /**
     * @param {?} _route
     * @param {?} _state
     * @return {?}
     */
    XoBreadcrumbsResolver.prototype.resolve = /**
     * @param {?} _route
     * @param {?} _state
     * @return {?}
     */
    function (_route, _state) {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            /** @type {?} */
            var onSubscribe = (/**
             * @param {?} response
             * @return {?}
             */
            function (response) {
                if (response.success)
                    resolve(response.breadcrumbs);
                resolve();
            });
            /** @type {?} */
            var url = ((_route.data.url) ? (_route.data.url) : _state.url.split(/[?#]/)[0]);
            _this._routesService.breadcrumbs(url).subscribe(onSubscribe);
        }));
    };
    XoBreadcrumbsResolver.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    XoBreadcrumbsResolver.ctorParameters = function () { return [
        { type: XoApiRoutesService }
    ]; };
    return XoBreadcrumbsResolver;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    XoBreadcrumbsResolver.prototype._routesService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: src/services/api/api.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoApiModule = /** @class */ (function () {
    function XoApiModule() {
    }
    XoApiModule.decorators = [
        { type: NgModule, args: [{
                    providers: [
                        XoApiService,
                        XoApiRequestService,
                        XoApiOptionsService,
                        XoApiMenusService,
                        XoApiPostsService,
                        XoApiTermsService,
                        XoApiRoutesService
                    ]
                },] }
    ];
    return XoApiModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: src/angular-xo.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var XoModule = /** @class */ (function () {
    function XoModule() {
    }
    XoModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        BrowserModule,
                        RouterModule,
                        HttpClientModule,
                        XoGlobalsModule.forBrowser(),
                        XoApiModule
                    ],
                    providers: [
                        XoRouteService,
                        XoPostResolver,
                        XoPostComponent,
                        XoPostsListComponent,
                        XoPostTermComponent,
                        XoTermResolver,
                        XoTermComponent,
                        XoBreadcrumbsResolver
                    ]
                },] }
    ];
    return XoModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: angular-xo.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { XoApiConfigService, XoApiMenusService, XoApiOptionsService, XoApiPostsService, XoApiRequestService, XoApiRoutesService, XoApiService, XoApiTermsService, XoBreadcrumbsResolver, XoGlobals, XoGlobalsModule, XoInitRoutes, XoModule, XoPostComponent, XoPostResolver, XoPostTermComponent, XoPostsListComponent, XoRouteService, XoTermComponent, XoTermResolver, XoBrowserGlobals as ɵa, XoNodeGlobals as ɵb, XoApiModule as ɵc };
//# sourceMappingURL=angular-xo.js.map
