import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { XoGlobals } from '../globals/globals.service';
export declare class XoApiRequestService {
    _globals: XoGlobals;
    _http: HttpClient;
    /**
     * Base path or URL of the Xo API.
     */
    apiUrl: string;
    constructor(_globals: XoGlobals, _http: HttpClient);
    /**
     * Perform a GET request to the Xo API.
     *
     * @param path Relative path of the API endpoint.
     * @param params Input parameters added to the GET request.
     * @param useCache Pro feature, optionally retrieve the item from apiCache.
     */
    get<T>(path: string, params?: any, useCache?: boolean): Observable<T>;
    /**
     * Perform a POST request to the Xo API.
     *
     * @param path Relative path of the API endpoint.
     * @param params Input parameters added to the POST request.
     * @param useCache Pro feature, optionally retrieve the item from apiCache.
     */
    post<T>(path: string, params: any, useCache?: boolean): Observable<T>;
    private cacheCheck;
}
