import { Observable } from 'rxjs';
import { XoApiService } from '../api.service';
import { XoPosts } from './posts';
/**
 * Provide endpoints for retrieving, searching, and listing various post types.
 */
export declare class XoApiPostsService extends XoApiService {
    /**
     * Get a post using either the relative URL or postId.
     */
    get(url: string): Observable<XoPosts.PostsGetResponse>;
    /**
     * Get a post draft or preview only if user logged in and can view.
     */
    getDraftOrPreview(postId: number): Observable<XoPosts.PostsGetResponse>;
    /**
     * Filter, search, or list posts by various properties similar to get_posts().
     */
    filter(params: XoPosts.PostsFilterRequest): Observable<XoPosts.PostsFilterResponse>;
    /**
     * Retrieve the config for a given post type.
     */
    config(postType: string): Observable<XoPosts.PostsConfigResponse>;
}
