import { Observable } from 'rxjs';
import { XoApiService } from '../api.service';
import { XoRoutes } from './routes';
/**
 * Provide endpoints for retrieving dynamic routes and sitemap.
 */
export declare class XoApiRoutesService extends XoApiService {
    /**
     * Get the dynamic route configuration.
     */
    get(): Observable<XoRoutes.RoutesGetResponse>;
    /**
     * Get breadcrumb sitemap entries for the given URL.
     */
    breadcrumbs(url: string): Observable<XoRoutes.BreadcrumbsResponse>;
    /**
     * Get sitemap entries for posts and terms.
     */
    sitemap(): Observable<XoRoutes.SitemapResponse>;
}
