import { Observable } from 'rxjs';
import { XoApiService } from '../api.service';
import { XoTerms } from './terms';
/**
 * Provide endpoints for filtering terms.
 */
export declare class XoApiTermsService extends XoApiService {
    /**
     * Get a taxonomy and term by url.
     */
    get(url: string): Observable<XoTerms.TermsGetResponse>;
    /**
     * Filter, search, or list terms by various properties similar to get_terms().
     */
    filter(params: XoTerms.TermsFilterRequest): Observable<XoTerms.TermsFilterResponse>;
}
